/* Bare-bones version for FLEXT integration */

#include<stdio.h>
#include<stdlib.h>
#include<math.h>


  int popsize=500;
  int dimen=2;
  int iterations=1000;
  int NeighborHoodSize=3;
  float khi=0.729;
  float HalfPhi=2.05;


main()
{

  float result,CurrentVal,rand1,rand2;
  int i,j,k,g,neighbor;

  int target[2];

  /* Max 50 particle, with 2 dimentions, 3 neighbors NOT GENERATED FROM ABOVE */
  float current_position[popsize][dimen];
  float velocity[popsize][dimen];
  float previous_best_position[popsize][dimen];
  int neighbors[popsize][NeighborHoodSize];
  float previous_best[popsize];

  int done=0,gbest,pixel_x,pixel_y,c=0;
  float tmp;

  /* Seed Random Values */
  srand48(time());

  /* Set default target values */
  for(i=0; i<dimen;i++)
  {
  	target[i]=0;
  }

  /* Randomize the positions and velocities of members of the population */
  /* For each Particle */
  for(i=0; i<popsize; i++)
  {
    /* For each dimention */
    for(j=0; j<dimen; j++)
    {
	// This method does work, but depends on SDL, looking for better solution

        /* fill current position array to random numbers 5-10 */
	current_position[i][j]=(int)(drand48()*5+5);

	/* Copy the current position array into the previous position array */
	previous_best_position[i][j]=current_position[i][j];

	/* Set an initial velocity for each particle between 0-1 */
	velocity[i][j]=drand48();

	/* Set a random number of the velocities to negative */
	if ( drand48() < 0.5 )
	{
		velocity[i][j]=velocity[i][j]*-1;
	}
    }
    
    /* Set the best solution for this particle by testing w/ sphere function */
    result=0;
 
    for(k=0; k<dimen; k++)
    {
	/* Pythagoras - c^2=(a^2+b^2) - for each dimention!! */
        result += pow((current_position[i][k]-(((float)target[k]-200)/60)),2);
    }

    previous_best[i]=result;

  }

  /* Make Neighborhoods */

  /* For each particle */
  for(i=0; i<popsize; i++)
  {
    /* for each neighbor */
    for(j=0; j<NeighborHoodSize; j++)
    {
        /* Connect each neighbor to its previous and next particle */
	neighbors[i][j]=i-1+j;

	/* Make a ring so the first and last particles are connected */
	if(neighbors[i][j] < 0)
	{
	  neighbors[i][j]=popsize-neighbors[i][j]-2;
	} else if(neighbors[i][j] >= popsize)
	{
	  neighbors[i][j]=neighbors[i][j]-popsize;
	}
    }
  }

  /* Set initial global best to first particle */
  gbest=0;
    
  /* Main event loop */
  for(c=0;c<iterations;c++)
  {
    /* Swarm Iterate */
    /* For each particle */
    for(i=0; i<popsize; i++)
    {
	/* This is the sphere function DUPLICATE */
        result=0;
	
	for(k=0; k<dimen; k++)
        {
          /* Pythagoras - c^2=(a^2+b^2) - for each dimention!! */
          result += pow((current_position[i][k]-(((float)target[k]-200)/60)),2);
        }

        CurrentVal=result;

	g=neighbors[i][0];

	/* For each Neightbor */
	for(k=0; k<NeighborHoodSize; k++)
	{
	  neighbor=neighbors[i][k];
	  if(previous_best[neighbor] < previous_best[g])
	  {
	    g=neighbor;
	  }
          if(CurrentVal < previous_best[i])
	  {
	    if(CurrentVal < previous_best[gbest])
	    {
	      gbest=i;
	    }
          
	    for(j=0; j<2; j++)
	    {
	      previous_best_position[i][j]=current_position[i][j];
	    }

 	    previous_best[i]=CurrentVal;
	  }
        
          for(j=0; j<dimen;j++)
	  {
            rand1=drand48();
            rand2=drand48();

	    velocity[i][j]=khi*(velocity[i][j] + rand1*HalfPhi*(previous_best_position[i][j] - current_position[i][j]) + rand2*HalfPhi*(previous_best_position[g][j] - current_position[i][j]));
	    current_position[i][j]=current_position[i][j]+velocity[i][j];
  
	  }
        }
    }
	/* Print out optimization */
	printf("%f\n", previous_best[gbest]);
  }
}

